// Dynamap.cpp
// Titan SH2 Dynamic Recompilation Routines

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "dynamap.h"
#include "sh2.h"
#include "mem.h"

//Block *recompEngine;
int blockCount;
unsigned char *codeptr;

Block *dynaInit(Block *dynaCode)
{
	dynaCode = (Block*)malloc(sizeof(Block)*NUMOFBLOCKS);
	memset((void*)dynaCode, 0, sizeof(Block)*NUMOFBLOCKS); 
	blockCount = 0;
	return dynaCode;
}

int dynaCheckPC(tagSH2 *sh2, Block *dynaCode)
{
	unsigned int register i;

	// check to see if current PC is already generated
	for (i=0;i<NUMOFBLOCKS;i++)
	{
		if (dynaCode[i].b_addr == PC && dynaCode[i].reserved == (unsigned long)sh2) {
			// set PC to the end of the block
			PC = dynaCode[i].e_addr;
			blockCount = i;
			return 1;
		}
	}

	return 0;
}

void dynaMakeBlock(tagSH2 *sh2, Block *dynaCode)
{
	unsigned char *startptr;

	// check to see if block was already compiled
	if (dynaCheckPC(sh2, dynaCode))
		return;

	dynaCode[blockCount].b_addr = PC;
	dynaCode[blockCount].reserved = (unsigned long)sh2;
	startptr = (unsigned char*)dynaCode[blockCount].code;

	// add prolog and pass address of registers
	memcpy((void*)dynaCode[blockCount].code, (void*)prologue, PROLOGSIZE);
	codeptr = startptr + PROLOGSIZE;

	while (codeptr - startptr < MAXBLOCKSIZE - MAXINSTRSIZE - EPILOGSIZE - PROLOGSIZE)
	{
		//translate the opcode and insert code
		//opcode = memGetWord(PC+2);
		//opFunc[(opcode>>12)&0xf];

		// (if jump op, run delay branch, change PC and quit)
		//increment the codeptr
	}

	memcpy((void*)codeptr, (void*)epilogue, EPILOGSIZE);
	// update ending PC (incase block is resused)
	dynaCode[blockCount].e_addr = PC;
}
