// Titan SH2 Dynamic Recompilation Routines
// Modified 8/10/00

#ifndef _DYNAMAP_H
#define _DYNAMAP_H

#include "sh2.h"

#if defined(__i386__) || defined(_M_IX86)
#include "./Cpu/i386/dynalib.h"
#endif

#define NUMOFBLOCKS		16
#define MAXINSTRSIZE	4
#define MAXBLOCKSIZE	1024

#define dynaRunBlock(x,y)	((dynaFunc)((void*)((unsigned char *)(y[blockCount++].code))))(x); \
						if (blockCount == NUMOFBLOCKS) \
							blockCount = 0;

typedef void (*dynaFunc)(tagSH2*);

struct Block {
	unsigned char code[MAXBLOCKSIZE];
	unsigned long b_addr; //beginning PC
	unsigned long e_addr; //ending PC
	unsigned long reserved;
};

//extern Block *recompEngine;
extern int blockCount;
extern unsigned char *codeptr;

Block *dynaInit(Block*);
int dynaCheckPC(tagSH2*, Block*);
void dynaMakeBlock(tagSH2*, Block*);

#endif