// SOUND.CPP
// M68k Emulation (and SCSP Abstraction)

#include "global.h"
#include "m68k.h"

#define SCSPMEMSIZE 0x200000

#if defined(__i386__) || defined(_M_IX86)

struct GENITAL68K_FETCHREGION fetch[] = 
{
	{ 0x00000,	0x80000, (GENITAL68K_UINT32)Sound },
	{ -1,       -1,       GENITAL68K_NULL }
};

/*
struct GENITAL68K_DATAREGION fetch[] = 
{
	{ 0x00000,	0x80000, (GENITAL68K_UINT32)Sound, NULL },
	{ -1,       -1,       GENITAL68K_NULL,  GENITAL68K_NULL }
};
*/

void init68k(void)
{
	Genital68KInit();

	genital68kcontext.fetch = fetch;
	genital68kcontext.read_byte = fetch;
	genital68kcontext.read_word = fetch;
	genital68kcontext.read_long = fetch;
	genital68kcontext.write_byte = fetch;
	genital68kcontext.write_word = fetch;
	genital68kcontext.write_long = fetch;
}

void step68k(int cycles)
{
	Genital68KRun(cycles);
}

void reset68k(void)
{
	Genital68KReset();
}

void stop68k(void)
{
	Genital68KClearCycles();
}

#else

void init68k(void);
{}

void reset68k(void)
{}

void step68k(int cycles)
{}

void stop68k(void)
{}

#endif

