// PLUGIN.H
// Titan Plugin Structures

#ifndef _PLUGIN_H
#define _PLUGIN_H

#define SAT_VDP_PLUGIN	0
#define SAT_SND_PLUGIN	1
#define SAT_SCD_PLUGIN	2
#define SAT_PAD_PLUGIN	3

#ifdef __GNUC__
#define PLUGINCALL
#else
#define	PLUGINCALL __stdcall
#endif

typedef struct {
	char *name;
	unsigned char plugType;
	unsigned long plugVersion;
} tagPlugInfo;

typedef tagPlugInfo (PLUGINCALL *PlugInfo)(void);

#ifdef WIN32
#include <windows.h>

// START: Integrated Plugins
#define	VDP_FUNC(x, y)	y
#define VDP_UPD_REGS(x)	VDP_UpdateRegs(x)
#include "./Win32/vdp.h"

#define SCD_FUNC(x, y)	y
#define SCD_READ(x)		SCD_ReadRegs(x)
#define SCD_WRITE(x, y)	SCD_WriteRegs(x, y)
#include "./Win32/cdrom.h"
// END: Integrated VDP

//#define VDP_UPD_REGS(x)	((VDPRegs)GetProcAddress(DLL_VDP, "VDP_UpdateRegs"))

//#define	VDP_FUNC(x, y)	((x)GetProcAddress(DLL_VDP, "y"))
//#define	SCD_FUNC(x, y)	((x)GetProcAddress(DLL_SCD, "y"))
extern HINSTANCE DLL_VDP, DLL_SND, DLL_SCD;
#else

#define VDP_UPD_REGS(x)	VDP_UpdateRegs(x)
#define SCD_READ(x)		SCD_ReadRegs(x)
#define SCD_WRITE(x, y)	SCD_WriteRegs(x, y)

#endif

typedef void (PLUGINCALL *voidPlugCall)(void);
typedef int (PLUGINCALL *retPlugCall)(void);

// VDP Function Prototypes
typedef int (PLUGINCALL *VDPInit)(unsigned char*, unsigned char*, unsigned long);
typedef void (PLUGINCALL *VDPRegs)(unsigned long);

// SCU Function Prototypes
typedef int (PLUGINCALL *SCDInit)(unsigned long);
typedef void (PLUGINCALL *SCDWrite)(unsigned long, unsigned long);
typedef unsigned short (PLUGINCALL *SCDRead)(unsigned long);

#endif